﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        FpSpread1.Sheets.Clear()
        FpSpread1.Sheets.Add(New customSheet2Level)
        FpSpread1.Sheets(0).RowCount = 10
        FpSpread1.Sheets(0).ColumnCount = 1
        Dim r As Integer
        For r = 0 To FpSpread1.Sheets(0).RowCount - 1
            FpSpread1.Sheets(0).Cells(r, 0).Value = "Name" + (r + 1).ToString()
        Next
    End Sub
End Class
Public Class customSheet2Level
    Inherits FarPoint.Win.Spread.SheetView
    Public Overrides ReadOnly Property ChildRelationCount() As Integer
        Get
            Return 1
        End Get
    End Property

    Public Overrides Function GetChildView(ByVal row As Integer, ByVal relationIndex As Integer) As FarPoint.Win.Spread.SheetView
        Dim child As customSheet = CType(FindChildView(row, 0), customSheet)
        If Not (child Is Nothing) Then Return child
        child = New customSheet
        child.RowCount = 5
        child.ColumnCount = 3
        Dim r As Integer
        For r = 0 To child.RowCount - 1
            child.Cells(r, 0).Value = "Address" + (r + 1).ToString()
            child.Cells(r, 1).Value = (r + 1) * 10
            child.Cells(r, 2).Value = (r + 1) * 20
        Next
        child.Parent = Me
        child.SheetName = row.ToString

        ChildViews.Add(child)
        Return child
    End Function

    Public Overrides Function FindChildView(ByVal row As Integer, ByVal relationIndex As Integer) As FarPoint.Win.Spread.SheetView
        Dim id As String = row.ToString
        Dim View As customSheet
        For Each View In ChildViews
            If View.SheetName = id Then Return View
        Next
        Return Nothing
    End Function
End Class


Public Class customSheet
    Inherits FarPoint.Win.Spread.SheetView
    Public Overrides ReadOnly Property ChildRelationCount() As Integer
        Get
            Return 1
        End Get
    End Property
    Public Overrides Function GetChildView(ByVal row As Integer, ByVal relationIndex As Integer) As FarPoint.Win.Spread.SheetView
        Dim child As customChild = CType(FindChildView(row, relationIndex), customChild)
        If Not (child Is Nothing) Then Return child
        child = New customChild
        child.RowCount = 5
        child.ColumnCount = 5
        Dim r As Integer
        For r = 0 To child.RowCount - 1
            child.Cells(r, 0).Value = "City" + (r + 1).ToString()
            child.Cells(r, 1).Value = (r + 1) * 10
            child.Cells(r, 2).Value = (r + 1) * 20
            child.Cells(r, 3).Value = (r + 1) * 30
            child.Cells(r, 4).Value = (r + 1) * 40
        Next
        child.Parent = Me
        child.SheetName = row.ToString
        ChildViews.Add(child)
        Return child
    End Function
    Public Overrides ReadOnly Property ParentRowIndex() As Integer
        Get
            Return CInt(SheetName)
        End Get
    End Property
End Class
Public Class customChild
    Inherits FarPoint.Win.Spread.SheetView
    Public Overrides ReadOnly Property ParentRowIndex() As Integer
        Get
            Return CInt(SheetName)
        End Get
    End Property
End Class
